/* "eqcs_gate_array.h"
 * Copyright (C) 1999 Peter Belkner <pbelkner@berlin.snafu.de>
 *
 * This file is part of the eqcs library. This library is free
 * software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License as published by the Free Software
 * Foundation; either version 2, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; see the file COPYING.  If not, write to the
 * Free Software Foundation, 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */
#ifndef	_EQCS_GATE_ARRAY_H_
#ifndef __GNUG__
#pragma interface
#endif
#define	_EQCS_GATE_ARRAY_H_

#include "eqcs_gate.h"

class EqcsGateArrayRep;

/*****************************************************************************\
*	gate array																  *
\*****************************************************************************/

class EqcsGateArray: public EqcsHandle {
public:
	typedef EqcsHandle base_t;
	typedef EqcsGateArrayRep rep_t;

	EqcsGateArray(rep_t *rep);
	EqcsGateArray();

	void push_back(const EqcsGate &gate);

	// Some technical uitilities.
	inline rep_t *operator->() const
		{ return (rep_t *)EqcsHandle::rep(); }
	inline rep_t *rep() const
		{ return (rep_t *)EqcsHandle::rep(); }
};

#endif	//	_EQCS_GATE_ARRAY_H_
